---
title: CacheStorage.has()
slug: Web/API/CacheStorage/has
tags:
  - API
  - CacheStorage
  - Experimental
  - Method
  - Reference
  - Service Workers
  - ServiceWorker
  - has
---
<p>{{APIRef("Service Workers API")}}</p>

<p>The <strong><code>has()</code></strong> method of the {{domxref("CacheStorage")}} interface returns a {{jsxref("Promise")}} that resolves to <code>true</code> if a {{domxref("Cache")}} object matches the <code>cacheName</code>.</p>

<p>You can access <code>CacheStorage</code> through the global {{domxref("WindowOrWorkerGlobalScope.caches", "caches")}} property.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">caches.has(<em>cacheName</em>).then(function(<em>boolean</em>) {
  // true: your cache exists!
});
</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt><code>cacheName</code></dt>
 <dd>A {{domxref("DOMString")}} representing the name of the {{domxref("Cache")}} object you are looking for in the {{domxref("CacheStorage")}}.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>a {{jsxref("Promise")}} that resolves to <code>true</code> if the cache exists or <code>false</code> if not.</p>

<h2 id="Examples" style="line-height: 30px; font-size: 2.14285714285714rem;">Examples</h2>

<p>The following example first checks whether a cache called 'v1' exists. If so, we add a list of assets to it. If not then we run some kind of cache set-up function.</p>

<pre class="brush: js">caches.has('v1').then(function(hasCache) {
  if (!hasCache) {
    someCacheSetupfunction();
  } else {
    caches.open('v1').then(function(cache) {
      return cache.addAll(myAssets);
    });
  }
}).catch(function() {
  // Handle exception here.
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#cache-storage-has', 'CacheStorage: has')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.CacheStorage.has")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li>{{domxref("Cache")}}</li>
 <li>{{domxref("WindowOrWorkerGlobalScope.caches")}}</li>
</ul>
